/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.52 by edhill, Wed Dec 1 16:59:42 2004 UTC revision 1.73 by jmc, Sat Dec 3 23:23:41 2005 UTC
# Line 27  usage() Line 27  usage()
27      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
28      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
29      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
30        echo "  (-odir) STRING           used to build output directory name"
31        echo "                             (DEF=\"hostname\")"
32      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"
33      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
34      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
# Line 95  testoutput_for_prop() Line 97  testoutput_for_prop()
97      fi      fi
98      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/output.txt ]; then
99          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
100          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
101          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 3 ]; then
102              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
103                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
104              fi              fi
# Line 110  testoutput_for_prop() Line 112  testoutput_for_prop()
112          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
113      fi      fi
114      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
115      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
116      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 3 ]; then
117          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
118              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
119          fi          fi
120          return 99          return 99
121      fi      fi
122        if [ $lncntA -ne $lncntB ]; then
123            if [ $verbose -gt 0 ]; then
124                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
125            fi
126            return 99
127        fi
128        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
129        if [ $has_nan -gt 0  ] ; then
130            echo testoutput_for_prop: output.txt contains $has_nan NaN values  1>&2
131            return 99
132        fi
133        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
134        if [ $has_inf -gt 0  ] ; then
135            echo testoutput_for_prop: output.txt contains $has_inf Inf values  1>&2
136            return 99
137        fi
138      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
139          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2
140      fi      fi
# Line 294  genmakemodel() Line 312  genmakemodel()
312              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
313                  command="$command -ieee"                  command="$command -ieee"
314              fi              fi
315                if test "x$MPI" = xt ; then
316                    command="$command -mpi"
317                fi
318              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
319              $command > make.log 2>&1              $command > make.log 2>&1
320              RETVAL=$?              RETVAL=$?
# Line 339  makeclean() Line 360  makeclean()
360      fi      fi
361  }  }
362    
363    postclean()
364    {
365        # postclean directory
366        if test "x$POSTCLEAN" = xt ; then
367            (
368                cd $1;
369                if test -r Makefile ; then
370                    $MAKE CLEAN >> /dev/null 2>&1
371                fi
372                exit 0
373            )
374        fi
375    }
376    
377  makedependmodel()  makedependmodel()
378  {  {
379      # makedependmodel directory      # makedependmodel directory
# Line 450  linkdata() Line 485  linkdata()
485              if test "x$ADM" = x ; then              if test "x$ADM" = x ; then
486                  files=`( cd ../input ; ls -1 | grep -v CVS )`                  files=`( cd ../input ; ls -1 | grep -v CVS )`
487                  for i in $files ; do                  for i in $files ; do
488                      if test ! -d "../input/"$i ; then                      if test ! -d "../input/"$i -a ! -f $i ; then
489                          ln -sf "../input/"$i $i                          ln -sf "../input/"$i $i
490                      fi                      fi
491                  done                  done
# Line 520  createcodelet() Line 555  createcodelet()
555  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
556    int linnum,best,lncnt;    int linnum,best,lncnt;
557    double a,b,abave,relerr;    double a,b,abave,relerr;
558    best = -16;    best = -22;
559    lncnt = 0;    lncnt = 0;
560    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & (lncnt+=1) < 999 )  {
561      scanf("%d", &linnum);      scanf("%d", &linnum);
# Line 529  int main( int argc, char** argv )  { Line 564  int main( int argc, char** argv )  {
564      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
565      if (abave > 0.0) {      if (abave > 0.0) {
566        relerr=fabs(a-b)/abave;        relerr=fabs(a-b)/abave;
567        if (relerr > 0.0) {        if (relerr > 0.0) { linnum = (int)rint(log10(relerr)); }
568          linnum = (int)log10(relerr);        else { linnum = -16 ; }
569          best = (best > linnum) ? best : linnum;        best = (best > linnum) ? best : linnum;
       }  
     }  
     else {  
       if (best == -16 && abave != 0)  best = -22;  
570      }      }
571    }    }
572    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
# Line 543  int main( int argc, char** argv )  { Line 574  int main( int argc, char** argv )  {
574    return 0;    return 0;
575  }  }
576  EOF  EOF
577      cc -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tmp_cmpnum tmp_cmpnum.c -lm
578    
579      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tmp_cmpnum ]; then
580          echo "OK"          echo "OK"
581          return 0          return 0
582      else      else
583          echo          echo
584          echo "ERROR: failed to compile comparison code"          echo "ERROR: failed to compile comparison code -- please specify"
585            echo "  a C compiler using the CC environment variable."
586          exit 1          exit 1
587      fi      fi
588  }  }
# Line 630  QUICK=f Line 662  QUICK=f
662  NOGENMAKE=f  NOGENMAKE=f
663  NOCLEAN=f  NOCLEAN=f
664  NODEPEND=f  NODEPEND=f
665    POSTCLEAN=f
666    
667  BASH=  BASH=
668  OPTFILE=NONE  OPTFILE=NONE
# Line 639  MPACKDIR="../tools/mpack-1.6" Line 672  MPACKDIR="../tools/mpack-1.6"
672  HAVE_MPACK=  HAVE_MPACK=
673  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
674  COMMAND=  COMMAND=
675  MAKE=make  if test "x$MAKE" = x ; then
676        MAKE=make
677    fi
678    if test "x$CC" = x ; then
679        CC=cc
680    fi
681  JOBS=  JOBS=
682  MPI=f  MPI=f
683    OUTDIR=
684  DELDIR=  DELDIR=
685    
686  ADM=  ADM=
# Line 698  for ac_option ; do Line 737  for ac_option ; do
737          -make=* | --make=*)          -make=* | --make=*)
738              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
739    
740            -odir | --odir)
741                ac_prev=OUTDIR ;;
742            -odir=* | --odir=*)
743                OUTDIR=$ac_optarg ;;
744    
745          -ptracers | --ptracers | -ptr | --ptr)          -ptracers | --ptracers | -ptr | --ptr)
746              ac_prev=PTRACERS_NUM ;;              ac_prev=PTRACERS_NUM ;;
747          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
# Line 707  for ac_option ; do Line 751  for ac_option ; do
751          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
752    
753          -clean | --clean)          -clean | --clean)
754              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
755    
756          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
757              QUICK=t ;;              QUICK=t ;;
# Line 718  for ac_option ; do Line 762  for ac_option ; do
762          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
763              NODEPEND=t ;;              NODEPEND=t ;;
764    
765            -postclean | --postclean | -pc | --pc)
766                POSTCLEAN=t ;;
767    
768          -mpi) MPI=t ;;          -mpi) MPI=t ;;
769    
770          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
# Line 784  MACH=`hostname` Line 831  MACH=`hostname`
831  UNAMEA=`uname -a`  UNAMEA=`uname -a`
832  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
833  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
834    if test "x$OUTDIR" != x ; then
835        BASE="tr_"$OUTDIR"_"$DATE"_"
836    fi
837  DNUM=0  DNUM=0
838  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
839  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 873  for dir in $TESTDIRS ; do Line 923  for dir in $TESTDIRS ; do
923          if test -r $dir/input/Makefile ; then          if test -r $dir/input/Makefile ; then
924              ( cd $dir/input ; make CLEAN )              ( cd $dir/input ; make CLEAN )
925          fi          fi
926            (
927                cd $dir
928                rm -rf tr_run.*
929            )
930          continue          continue
931      fi      fi
932    
# Line 881  for dir in $TESTDIRS ; do Line 935  for dir in $TESTDIRS ; do
935      fout=      fout=
936      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
937          fout=$dir"/results/output.txt"          fout=$dir"/results/output.txt"
         check_for_add_mon_output  $fout  
938      else      else
939          fout=$dir"/results_ad/output.txt_adm"          fout=$dir"/results_ad/output.txt_adm"
940      fi      fi
# Line 889  for dir in $TESTDIRS ; do Line 942  for dir in $TESTDIRS ; do
942          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
943          continue          continue
944      fi      fi
945        if test "x$ADM" = x ; then
946            check_for_add_mon_output  $fout
947        fi
948    
949      # Check for additional types of monitor output      # Check for additional types of monitor output
950    
# Line 935  for dir in $TESTDIRS ; do Line 991  for dir in $TESTDIRS ; do
991      echo "Experiment:  $dir"      echo "Experiment:  $dir"
992      echo      echo
993      unset genmake makedepend make run      unset genmake makedepend make run
994      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
995    
996      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
997      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 966  for dir in $TESTDIRS ; do Line 1022  for dir in $TESTDIRS ; do
1022          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1023          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1024    
         OLD_COMMAND=$COMMAND  
         COMMAND="./mitgcmuv > output.txt"  
1025          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1026              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"              unset run
1027              mkdir "$dir/tr_run.$ex"              results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
1028              links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`              #  Create an output dir for each OPTFILE/tdir.ex combination
1029                rel_CDIR=$DRESULTS"/"$dir"."$ex
1030                mkdir $rel_CDIR
1031                CDIR=`pwd`"/$rel_CDIR"
1032                test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1033                for ldir in input.$ex input ; do
1034                    (
1035                        cd "$dir/$ldir" > /dev/null 2>&1
1036                        ls -1 2>/dev/null \
1037                            | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'
1038                    ) > tr_exrun_links
1039                    (
1040                        cd "$dir/tr_run.$ex"
1041                        cat ../../tr_exrun_links | while read i ; do
1042                            if test ! "x$i" = x ; then
1043                                test ! -r $i  &&  ln -s "../"$ldir"/"$i $i
1044                            fi
1045                        done
1046                    )
1047                    test -e tr_exrun_links  &&  rm -f tr_exrun_links
1048                done
1049                ldir=build
1050                (
1051                    cd "$dir/$ldir" > /dev/null 2>&1
1052                    ls -1 Makefile *.[fFhco] mitgcmuv  2>/dev/null \
1053                        | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'
1054                ) > tr_exrun_links
1055              (              (
1056                  cd "$dir/tr_run.$ex"                  cd "$dir/tr_run.$ex"
1057                  for i in $links; do                      cat ../../tr_exrun_links | while read i ; do
1058                      ln -s ../input/$i $i                          if test ! "x$i" = x ; then
1059                  done                              test ! -r $i  &&  ln -s "../"$ldir"/"$i $i
1060              )                          fi
1061              links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`                      done
             (  
                 cd "$dir/tr_run.$ex"  
                 for i in $links; do  
                     test -e $i  &&  rm -f $i  
                     ln -s ../input.$ex/$i $i  
                 done  
                 ln -s ../$builddir/mitgcmuv mitgcmuv  
1062              )              )
1063                test -e tr_exrun_links  &&  rm -f tr_exrun_links
1064              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1065                  && results=`testoutput $dir tr_run.$ex "."$ex`                  && results=`testoutput $dir tr_run.$ex "."$ex`
1066              fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`              fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
# Line 998  for dir in $TESTDIRS ; do Line 1072  for dir in $TESTDIRS ; do
1072              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1073              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1074              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1075              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1076          done          done
         COMMAND=$OLD_COMMAND  
1077      else      else
1078          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
1079          fres=$fres"$results   $dir"          fres=$fres"$results   $dir"
# Line 1012  for dir in $TESTDIRS ; do Line 1085  for dir in $TESTDIRS ; do
1085          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1086          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1087      fi      fi
1088    
1089        postclean $dir/$builddir
1090            
1091      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1092            
# Line 1053  fi Line 1128  fi
1128  rm -f tmp_cmpnum.c tmp_cmpnum  rm -f tmp_cmpnum.c tmp_cmpnum
1129    
1130  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1131      cat $SUMMARY      cat $SUMMARY | sed 's/ -- -- -- --//g'
1132      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1133          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1134      fi      fi
1135      cat $SUMMARY > tr_out.txt      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt
1136  fi  fi
1137    
1138  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.52  
changed lines
  Added in v.1.73

  ViewVC Help
Powered by ViewVC 1.1.22